/*
   name:    OOo-create-Interface-List.rex
   purpose: create an ooRexx program that defines and returns a list of OOo XInterfaces
   author:  ---rgf
   date:    2005-04-21
   changed: 2005-06-05, made sure that output file name is uppercased (for Unix to find it as well)
   version: 1.0.1
   needs:   "unzip"
   remarks: needs a file containing the directory entries of the OOo jar-archives
*/

jars="jurt.jar jut.jar javaunohelper.jar ridl.jar classes.jar sandbox.jar juh.jar unoil.jar"
xint.=0
xj=0
do while jars<>""
   parse var jars jar jars
   address cmd "unzip -v" jar " | rxqueue" -- send output to the ooRexx session queue
   i=0
   k=0
   do while queued()>0
      parse pull l
      i=i+1

      if pos("/X", l)>0 then
      do
         xj=xj+1
         k=k+1
         parse var l . . . . . . . rest

         xint.xj=changestr("/", rest, ".")~strip
         xint.0=xj
      end
   end
   .error~say( "j:" jar~right(20)":" i~right(5) "entries," k~right(5) " being XInterface class(es)")
end
.error~say("total of OOo XInterface classes:" xj)


call SysStemSort "xint."


-- say xint.0 "->" xint.1 "->" xint.xj", xj=" || xj

-- exit



-- parse arg fn
-- if fn="" then fn="aha.txt"

fo="OOo-Xinterfaces.rex"~translate  -- use uppercase, this way it can be found on Unix as well
so=.stream~new(fo)~~open("Replace") -- open stream, delete file

d=.directory~new

max=0
maxCN=0

so~say("/* "                                                                                               )
so~say("   name:    " fo                                                                                    )
so~say("   purpose:  define the list of OOo interface classes"                                             )
so~say("   author:   ---rgf "                                                                              )
so~say("   created: " date("s") time()                                                                      )
so~say('   usage:    just require file, then call the routine "OOo.getInterfaceList" to retrieve the list' )
so~say("*/"                                                                                                )
so~say
so~say("::ROUTINE OOo.getInterfaceList PUBLIC"                                                             )
so~say
so~say("   l=.list~of( -"                                                                                  )
do i=1 to xint.0
   rest=xint.i
   if right(rest, 6)=".class" then rest=left(rest, length(rest)-6)

   lword=substr(rest, lastpos(".", rest)+1)

   d~rest=rest
   if d~hasEntry(lword) then
   do
      so~say( "/* ---> ["rest"]: class name ["lword"] in use already! ("d~entry(lword)") */ - ")
   end
   else
   do
      d~setentry(lword, rest)
   end

   max=max(max, length(rest))
   maxCN=max(maxCN, length(lword))
   so~say(pp(rest))
end

so~say("   ) -- remove superfluous comma above!"            )
so~say
so~say("-- maximum fully qualified class-name length:" max", maximum length of class name:" maxCN  )
so~say('-- say l~items "items in list l" /* should be:' xj 'items */' )
so~say
so~say('   return l'                                           )

  /* this is a pretty print */
::routine pp
  return "0909"x || ('"'arg(1)'"')~left(74) ", -"

