/* initialize connection to server, get its Desktop-service and XComponentLoader interface */
xMsf=ooo.connect()   -- connect to server and retrieve remote multi server factory

-- Retrieve the Desktop object, we need its XComponentLoader interface
-- to load a new document

oDesktop         = xMsf~createInstance("com.sun.star.frame.Desktop")
xDesktop         = oDesktop~XDesktop          -- get desktop interface
xComponentLoader = xDesktop~XComponentLoader  -- get componentLoader interface

-- ---------- End of connection header ---------------

/* load an empty text document */
oTextComponent = xComponentLoader~loadComponentFromURL("private:factory/swriter", "_blank", 0, .OOo~noProps)

xDocument=oTextComponent~XTextDocument
xText=xDocument~getText

-- Now we could start writing into the document, for example:
-- xText~setString("A few words ...")

-- In order to set paragraph properties, we need a cursor for navigation.
-- A cursor can be retrieved from the controller,
-- the controller comes from the model,
-- and the model comes from the component, i.e. the application.

-- Get model from component
xModel=xDocument~XModel

-- The model knows its controller
xController = xModel~getCurrentController

-- The controller gives us the TextViewCursor
-- Query the viewcursor supplier interface
xViewCursorSupplier=xController~XTextViewCursorSupplier

-- Get the cursor
xViewCursor = xViewCursorSupplier~getViewCursor

-- Set the appropriate property for paragraph style
xCursorPropertySet=xViewCursor~XPropertySet

--  !! Note for Rexx users: You must point BSF4Rexx to the right method
--     using the invokeStrict function with type indicators ("ST" for String)
xCursorPropertySet~bsf.invokeStrict("setPropertyValue", "ST", "ParaStyleName", "ST", "Quotations")

-- Print the current page number  we need the XPageCursor interface for this
xPageCursor=xViewCursor~XPageCursor

-- This is written directly into the open document (see above).
xText~setString("The current page number is:" xPageCursor~getPage)

-- If we had not retrieved the text interface from the xTextDocument (see above),
-- we could now get it from the TextViewCursor.
-- The cursor is an XTextRange and has therefore a method getText():

-- The text creates a model cursor from the viewcursor
xModelCursor = xText~createTextCursorByRange(xViewCursor~getStart)

-- Now we could query XWordCursor, XSentenceCursor and XParagraphCursor
-- or XDocumentInsertable, XSortable or XContentEnumerationAccess
-- and work with the properties of com.sun.star.text.TextCursor

-- In this case we just go to the end of the paragraph and add some text.
-- Now get a paragraph cursor first.
xParagraphCursor=xModelCursor~XParagraphCursor

-- Go to the end of the paragraph
xParagraphCursor~gotoEndOfParagraph(.false)
xParagraphCursor~setString(" ***** Fin de semana! ******")


::requires OOO.CLS   -- ooRexx support for OpenOffice.org
